Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/MakerNotes.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/MakerNotes.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/MakerNotes.pm	(revision 34921)
@@ -1407,5 +1718,5 @@
 sub ProcessUnknownOrPreview($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dirStart = $$dirInfo{DirStart};
@@ -1413,13 +1724,13 @@
     # check to see if this is a preview image
     if ($dirLen > 6 and substr($$dataPt, $dirStart, 3) eq "\xff\xd8\xff") {
-        $exifTool->VerboseDir('PreviewImage');
-        if ($$exifTool{HTML_DUMP}) {
+        $et->VerboseDir('PreviewImage');
+        if ($$et{HTML_DUMP}) {
             my $pos = $$dirInfo{DataPos} + $$dirInfo{Base} + $dirStart;
-            $exifTool->HDump($pos, $dirLen, '(MakerNotes:PreviewImage data)', "Size: $dirLen bytes")
-        }
-        $exifTool->FoundTag('PreviewImage', substr($$dataPt, $dirStart, $dirLen));
+            $et->HDump($pos, $dirLen, '(MakerNotes:PreviewImage data)', "Size: $dirLen bytes")
+        }
+        $et->FoundTag('PreviewImage', substr($$dataPt, $dirStart, $dirLen));
         return 1;
     }
-    return ProcessUnknown($exifTool, $dirInfo, $tagTablePtr);
+    return ProcessUnknown($et, $dirInfo, $tagTablePtr);
 }
 
@@ -1430,5 +1741,5 @@
 sub WriteUnknownOrPreview($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dirStart = $$dirInfo{DirStart};
@@ -1437,12 +1748,12 @@
     # check to see if this is a preview image
     if ($dirLen > 6 and substr($$dataPt, $dirStart, 3) eq "\xff\xd8\xff") {
-        if ($$exifTool{NEW_VALUE}{$Image::ExifTool::Extra{PreviewImage}}) {
+        if ($$et{NEW_VALUE}{$Image::ExifTool::Extra{PreviewImage}}) {
             # write or delete new preview (if deleted, it can't currently be added back again)
-            $newVal = $exifTool->GetNewValues('PreviewImage') || '';
-            if ($exifTool->Options('Verbose') > 1) {
-                $exifTool->VerboseValue("- MakerNotes:PreviewImage", substr($$dataPt, $dirStart, $dirLen));
-                $exifTool->VerboseValue("+ MakerNotes:PreviewImage", $newVal) if $newVal;
+            $newVal = $et->GetNewValue('PreviewImage') || '';
+            if ($et->Options('Verbose') > 1) {
+                $et->VerboseValue("- MakerNotes:PreviewImage", substr($$dataPt, $dirStart, $dirLen));
+                $et->VerboseValue("+ MakerNotes:PreviewImage", $newVal) if $newVal;
             }
-            ++$$exifTool{CHANGED};
+            ++$$et{CHANGED};
         } else {
             $newVal = substr($$dataPt, $dirStart, $dirLen);
@@ -1450,5 +1761,5 @@
     } else {
         # rewrite MakerNote IFD
-        $newVal = Image::ExifTool::Exif::WriteExif($exifTool, $dirInfo, $tagTablePtr);
+        $newVal = Image::ExifTool::Exif::WriteExif($et, $dirInfo, $tagTablePtr);
     }
     return $newVal;
@@ -1461,21 +1772,21 @@
 sub ProcessUnknown($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $success = 0;
 
-    my $loc = LocateIFD($exifTool, $dirInfo);
+    my $loc = LocateIFD($et, $dirInfo);
     if (defined $loc) {
-        $exifTool->{UnknownByteOrder} = GetByteOrder();
-        if ($exifTool->Options('Verbose') > 1) {
-            my $out = $exifTool->Options('TextOut');
-            my $indent = $exifTool->{INDENT};
+        $$et{UnknownByteOrder} = GetByteOrder();
+        if ($et->Options('Verbose') > 1) {
+            my $out = $et->Options('TextOut');
+            my $indent = $$et{INDENT};
             $indent =~ s/\| $/  /;
             printf $out "${indent}Found IFD at offset 0x%.4x in maker notes:\n",
                     $$dirInfo{DirStart} + $$dirInfo{DataPos} + $$dirInfo{Base};
         }
-        $success = Image::ExifTool::Exif::ProcessExif($exifTool, $dirInfo, $tagTablePtr);
+        $success = Image::ExifTool::Exif::ProcessExif($et, $dirInfo, $tagTablePtr);
     } else {
-        $exifTool->{UnknownByteOrder} = ''; # indicates we tried but didn't set byte order
-        $exifTool->Warn("Unrecognized $$dirInfo{DirName}", 1);
+        $$et{UnknownByteOrder} = ''; # indicates we tried but didn't set byte order
+        $et->Warn("Unrecognized $$dirInfo{DirName}", 1);
     }
     return $success;
@@ -1502,5 +1813,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Matroska.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Matroska.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Matroska.pm	(revision 34921)
@@ -15,5 +15,5 @@
 use Image::ExifTool qw(:DataAccess :Utils);
 
-$VERSION = '1.04';
+$VERSION = '1.10';
 
 my %noYes = ( 0 => 'No', 1 => 'Yes' );
@@ -24,9 +24,10 @@
 %Image::ExifTool::Matroska::Main = (
     GROUPS => { 2 => 'Video' },
+    VARS => { NO_LOOKUP => 1 }, # omit tags from lookup
     NOTES => q{
         The following tags are extracted from Matroska multimedia container files. 
         This container format is used by file types such as MKA, MKV, MKS and WEBM. 
         For speed, ExifTool extracts tags only up to the first Cluster unless the
-        Verbose (-v) or Unknown = 2 (-U) option is used.  See
+        L<Verbose|../ExifTool.html#Verbose> (-v) or L<Unknown|../ExifTool.html#Unknown> = 2 (-U) option is used.  See
         L<http://www.matroska.org/technical/specs/index.html> for the official
         Matroska specification.
@@ -151,5 +152,5 @@
     },
     0x67 => {
-        Name => 'Timecode',
+        Name => 'TimeCode',
         Format => 'unsigned',
         Unknown => 1,
@@ -221,4 +222,6 @@
     0x2e => {
         Name => 'TrackEntry',
+        # reset TrackType member at the start of each track
+        Condition => 'delete $$self{TrackType}; 1',
         SubDirectory => { TagTable => 'Image::ExifTool::Matroska::Main' },
     },
@@ -632,4 +635,46 @@
     0x487 => { Name => 'TagString',         Format => 'utf8' },
     0x485 => { Name => 'TagBinary',         Binary => 1 },
+#
+# Spherical Video V2 (untested)
+#
+    0x7670 => {
+        Name => 'Projection',
+        SubDirectory => { TagTable => 'Image::ExifTool::Matroska::Projection' },
+    },
+);
+
+# Spherical video v2 projection tags (ref https://github.com/google/spatial-media/blob/master/docs/spherical-video-v2-rfc.md)
+%Image::ExifTool::Matroska::Projection = (
+    GROUPS => { 2 => 'Video' },
+    VARS => { NO_LOOKUP => 1 }, # omit tags from lookup
+    NOTES => q{
+        Projection tags defined by the Spherical Video V2 specification.  See
+        L<https://github.com/google/spatial-media/blob/master/docs/spherical-video-v2-rfc.md>
+        for the specification.
+    },
+    0x7671 => {
+        Name => 'ProjectionType',
+        Format => 'unsigned',
+        DataMember => 'ProjectionType',
+        RawConv => '$$self{ProjectionType} = $val',
+        PrintConv => {
+            0 => 'Rectangular',
+            1 => 'Equirectangular',
+            2 => 'Cubemap',
+            3 => 'Mesh',
+        },
+    },
+    0x7672 => [{
+        Name => 'EquirectangularProj',
+        Condition => '$$self{ProjectionType} == 1',
+        SubDirectory => { TagTable => 'Image::ExifTool::QuickTime::equi' },
+    },{
+        Name => 'CubemapProj',
+        Condition => '$$self{ProjectionType} == 2',
+        SubDirectory => { TagTable => 'Image::ExifTool::QuickTime::cbmp' },
+    }],
+    0x7673 => { Name => 'ProjectionPosYaw',   Format => 'float' },
+    0x7674 => { Name => 'ProjectionPosPitch', Format => 'float' },
+    0x7675 => { Name => 'ProjectionPosRoll',  Format => 'float' },
 );
 
@@ -673,5 +718,5 @@
 sub ProcessMKV($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     my $raf = $$dirInfo{RAF};
     my ($buff, $buf2, @dirEnd, $trackIndent, %trackTypes);
@@ -688,14 +733,14 @@
     my $hlen = GetVInt($buff, $pos);
     return 0 unless $hlen and $hlen > 0;
-    $pos + $hlen > $dataLen and $exifTool->Warn('Truncated Matroska header'), return 1;
-    $exifTool->SetFileType();
+    $pos + $hlen > $dataLen and $et->Warn('Truncated Matroska header'), return 1;
+    $et->SetFileType();
     SetByteOrder('MM');
     my $tagTablePtr = GetTagTable('Image::ExifTool::Matroska::Main');
 
     # set flag to process entire file (otherwise we stop at the first Cluster)
-    my $verbose = $exifTool->Options('Verbose');
-    my $processAll = ($verbose or $exifTool->Options('Unknown') > 1);
-    $$exifTool{TrackTypes} = \%trackTypes;  # store Track types reference
-    my $oldIndent = $$exifTool{INDENT};
+    my $verbose = $et->Options('Verbose');
+    my $processAll = ($verbose or $et->Options('Unknown') > 1);
+    $$et{TrackTypes} = \%trackTypes;  # store Track types reference
+    my $oldIndent = $$et{INDENT};
     my $chapterNum = 0;
 
@@ -705,6 +750,6 @@
             pop @dirEnd;
             # use INDENT to decide whether or not we are done this Track element
-            delete $$exifTool{SET_GROUP1} if $trackIndent and $trackIndent eq $$exifTool{INDENT};
-            $$exifTool{INDENT} = substr($$exifTool{INDENT}, 0, -2);
+            delete $$et{SET_GROUP1} if $trackIndent and $trackIndent eq $$et{INDENT};
+            $$et{INDENT} = substr($$et{INDENT}, 0, -2);
         }
         # read more if we are getting close to the end of our buffer
@@ -724,5 +769,5 @@
         $size < 0 and $unknownSize = 1, $size = 1e20;
         if (@dirEnd and $pos + $dataPos + $size > $dirEnd[-1][0]) {
-            $exifTool->Warn("Invalid or corrupted $dirEnd[-1][1] master element");
+            $et->Warn("Invalid or corrupted $dirEnd[-1][1] master element");
             $pos = $dirEnd[-1][0] - $dataPos;
             if ($pos < 0 or $pos > $dataLen) {
@@ -735,15 +780,15 @@
             next;
         }
-        my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tag);
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
         # just fall through into the contained EBML elements
         if ($tagInfo and $$tagInfo{SubDirectory}) {
             # stop processing at first cluster unless we are in verbose mode
             last if $$tagInfo{Name} eq 'Cluster' and not $processAll;
-            $$exifTool{INDENT} .= '| ';
-            $exifTool->VerboseDir($$tagTablePtr{$tag}{Name}, undef, $size);
+            $$et{INDENT} .= '| ';
+            $et->VerboseDir($$tagTablePtr{$tag}{Name}, undef, $size);
             push @dirEnd, [ $pos + $dataPos + $size, $$tagInfo{Name} ];
             if ($$tagInfo{Name} eq 'ChapterAtom') {
-                $$exifTool{SET_GROUP1} = 'Chapter' . (++$chapterNum);
-                $trackIndent = $$exifTool{INDENT};
+                $$et{SET_GROUP1} = 'Chapter' . (++$chapterNum);
+                $trackIndent = $$et{INDENT};
             }
             next;
@@ -756,5 +801,5 @@
             if (not $tagInfo or $more > 10000000) {
                 # don't try to skip very large blocks unless LargeFileSupport is enabled
-                last if $more > 0x80000000 and not $exifTool->Options('LargeFileSupport');
+                last if $more >= 0x80000000 and not $et->Options('LargeFileSupport');
                 $raf->Seek($more, 1) or last;
                 $buff = '';
@@ -786,5 +831,5 @@
             if ($fmt eq 'string' or $fmt eq 'utf8') {
                 ($val = substr($buff, $pos, $size)) =~ s/\0.*//s;
-                $val = $exifTool->Decode($val, 'UTF8') if $fmt eq 'utf8';
+                $val = $et->Decode($val, 'UTF8') if $fmt eq 'utf8';
             } elsif ($fmt eq 'float') {
                 if ($size == 4) {
@@ -793,5 +838,5 @@
                     $val = GetDouble(\$buff, $pos);
                 } else {
-                    $exifTool->Warn("Illegal float size ($size)");
+                    $et->Warn("Illegal float size ($size)");
                 }
             } else {
@@ -821,6 +866,6 @@
             # set group1 to Track/Chapter number
             if ($$tagInfo{Name} eq 'TrackNumber') {
-                $$exifTool{SET_GROUP1} = 'Track' . $val;
-                $trackIndent = $$exifTool{INDENT};
+                $$et{SET_GROUP1} = 'Track' . $val;
+                $trackIndent = $$et{INDENT};
             }
         }
@@ -832,18 +877,18 @@
         );
         if ($$tagInfo{NoSave}) {
-            $exifTool->VerboseInfo($tag, $tagInfo, Value => $val, %parms) if $verbose;
+            $et->VerboseInfo($tag, $tagInfo, Value => $val, %parms) if $verbose;
         } else {
-            $exifTool->HandleTag($tagTablePtr, $tag, $val, %parms);
+            $et->HandleTag($tagTablePtr, $tag, $val, %parms);
         }
         $pos += $size;  # step to next element
     }
-    $$exifTool{INDENT} = $oldIndent;
-    delete $$exifTool{SET_GROUP1};
+    $$et{INDENT} = $oldIndent;
+    delete $$et{SET_GROUP1};
     # override file type if necessary based on existing track types
     unless ($trackTypes{0x01} or $trackTypes{0x03}) {   # video or complex?
         if ($trackTypes{0x02}) {                        # audio?
-            $exifTool->OverrideFileType('MKA');
+            $et->OverrideFileType('MKA');
         } elsif ($trackTypes{0x11}) {                   # subtitle?
-            $exifTool->OverrideFileType('MKS');
+            $et->OverrideFileType('MKS');
         }
     }
@@ -870,5 +915,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
@@ -889,3 +934,2 @@
 
 =cut
-
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Microsoft.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Microsoft.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Microsoft.pm	(revision 34921)
@@ -5,4 +5,5 @@
 #
 # Revisions:    2010/10/01 - P. Harvey Created
+#               2011/10/05 - PH Added ProcessXtra()
 #
 # References:   1) http://research.microsoft.com/en-us/um/redmond/groups/ivm/hdview/hdmetadataspec.htm
@@ -13,7 +14,10 @@
 use strict;
 use vars qw($VERSION);
+use Image::ExifTool qw(:DataAccess :Utils);
 use Image::ExifTool::XMP;
 
-$VERSION = '1.03';
+$VERSION = '1.20';
+
+sub ProcessXtra($$$);
 
 # tags written by Microsoft HDView (ref 1)
@@ -71,6 +75,6 @@
         Microsoft Photo 1.0 schema XMP tags.  This is likely not a complete list,
         but represents tags which have been observed in sample images.  The actual
-        namespace prefix is "MicrosoftPhoto", but ExifTool shortens this to
-        "XMP-microsoft" in the family 1 group name.
+        namespace prefix is "MicrosoftPhoto", but ExifTool shortens this in the
+        family 1 group name.
     },
     CameraSerialNumber => { },
@@ -81,12 +85,15 @@
     LastKeywordXMP     => { List => 'Bag' },
     LensManufacturer   => { },
-    LensModel          => { },
+    LensModel          => { Avoid => 1 },
     Rating => {
         Name => 'RatingPercent',
         Notes => q{
-            normal Rating values of 1,2,3,4 and 5 stars correspond to RatingPercent
+            XMP-xmp:Rating values of 1,2,3,4 and 5 stars correspond to RatingPercent
             values of 1,25,50,75 and 99 respectively
         },
     },
+    CreatorAppId             => { Name => 'CreatorAppID' },
+    CreatorOpenWithUIOptions => { },
+    ItemSubType              => { },
 );
 
@@ -122,12 +129,30 @@
     PanoramicStitchTheta0 => { Writable => 'real' },
     PanoramicStitchTheta1 => { Writable => 'real' },
+    WhiteBalance0         => { Writable => 'real' },
+    WhiteBalance1         => { Writable => 'real' },
+    WhiteBalance2         => { Writable => 'real' },
+    Brightness            => { Avoid => 1 },
+    Contrast              => { Avoid => 1 },
+    CameraModelID         => { Avoid => 1 },
+    ExposureCompensation  => { Avoid => 1 },
+    PipelineVersion       => { },
+    StreamType            => { },
 );
 
 # Microsoft Photo 1.2 schema properties (MP) (ref PH)
+# (also ref http://msdn.microsoft.com/en-us/library/windows/desktop/ee719905(v=vs.85).aspx)
 my %sRegions = (
-    STRUCT_NAME => 'Regions',
+    STRUCT_NAME => 'Microsoft Regions',
     NAMESPACE   => 'MPReg',
-    Rectangle => { },
+    NOTES => q{
+        Note that PersonLiveIdCID element is called PersonLiveCID according to the
+        Microsoft specification, but in practice their software actually writes
+        PersonLiveIdCID, so ExifTool uses this too.
+    },
+    Rectangle         => { },
     PersonDisplayName => { },
+    PersonEmailDigest => { },
+    PersonLiveIdCID   => { },  # (see https://exiftool.org/forum/index.php?topic=4274.msg20368#msg20368)
+    PersonSourceID    => { },
 );
 %Image::ExifTool::Microsoft::MP = (
